<div class="container-fluid mt-0 mb-5 pl-0 pr-0">
  <form #dataLayoutForm="ngForm">
    <ejs-grid #dataControlListGrid [dataSource]="dataControlRules 
    | filter:searchtxt:['tgt_layer_nm', 'tgt_obj_nm', 'visual_rule_desc', 'tgt_metric_attr', 'rule_desc', 'rule_svrt']
    | arrayFilter:layerToFilter:['tgt_layer_id']:filterMetadata 
    | arrayFilter:objToFilter:['tgt_obj_id']:filterMetadata
    | multiAttributeArrayFilter:attrToFilter:['tgt_attr_id']:filterMetadata 
    | arrayFilter:ruleToFilter:['mstr_rule_id']:filterMetadata 
    | arrayFilter:severityToFilter:['rule_svrt']:filterMetadata 
    | arrayFilter:statusToFilter:['is_rule_actv']:filterMetadata" 
    (dataBound)="onDCListGridDataBound()" [allowPaging]="true" [allowSorting]="true"
      [showColumnChooser]="true" [toolbar]="gridToolbar" [pageSettings]="gridPageSettings" [allowTextWrap]="true">
      <e-columns>
        <e-column type='checkbox' [allowFiltering]='false' [allowSorting]='false' width='60'></e-column>
        <e-column field="tgt_layer_nm" headerText={{dataControl.ruleListColumn.objLayerNm}}>
          <ng-template #template let-dataControlRules>
            <span title="{{dataControlRules.tgt_layer_nm}}">
              {{dataControlRules.tgt_layer_nm !== null && dataControlRules.tgt_layer_nm?.length > 25 ? dataControlRules.tgt_layer_nm.slice(0,25).concat("...") : dataControlRules.tgt_layer_nm}}
            </span>
          </ng-template>
        </e-column>
        <e-column field="tgt_obj_nm" headerText={{dataControl.ruleListColumn.objNm}} isPrimaryKey="true">
          <ng-template #template let-dataControlRules>
            <span title="{{dataControlRules.tgt_obj_nm}}">
              {{dataControlRules.tgt_obj_nm !== null && dataControlRules.tgt_obj_nm?.length > 25 ? dataControlRules.tgt_obj_nm.slice(0,25).concat("...") : dataControlRules.tgt_obj_nm}}
            </span>
          </ng-template>
        </e-column>
        <e-column field="visual_rule_desc" headerText={{dataControl.ruleListColumn.aggregationFunction}} isPrimaryKey="true">
          <ng-template #template let-dataControlRules>
            <span title="{{dataControlRules.visual_rule_desc}}">
              {{dataControlRules.visual_rule_desc !== null && dataControlRules.visual_rule_desc?.length > 25 ? dataControlRules.visual_rule_desc.slice(0,25).concat("...") : dataControlRules.visual_rule_desc}}
            </span>
          </ng-template>
        </e-column>
        <e-column field="tgt_metric_attr" headerText={{dataControl.ruleListColumn.metricAttribute}} isPrimaryKey="true">
          <ng-template #template let-dataControlRules>
            <span title="{{dataControlRules.tgt_metric_attr}}">
              {{dataControlRules.tgt_metric_attr !== null && dataControlRules.tgt_metric_attr?.length > 25 ? dataControlRules.tgt_metric_attr.slice(0,25).concat("...") : dataControlRules.tgt_metric_attr}}
            </span>
          </ng-template>
        </e-column>
        <e-column field="rule_desc" headerText={{dataControl.ruleListColumn.ruleDescription}} isPrimaryKey="true">
          <ng-template #template let-dataControlRules>
            <span title="{{dataControlRules.rule_desc}}">
              {{dataControlRules.rule_desc !== null && dataControlRules.rule_desc?.length > 25 ? dataControlRules.rule_desc.slice(0,25).concat("...") : dataControlRules.rule_desc}}
            </span>
          </ng-template>
        </e-column>
        <e-column field="actv_disp" headerText="{{dataControl.ruleListColumn.status}}" width='100' class="justify-content-center">
          <ng-template #template let-dataControlRules>
            <div class="switch">
              {{dataControlRules.is_rule_actv?'Yes':''}}
              <ejs-switch [checked]="dataControlRules.is_rule_actv" [disabled]="true"></ejs-switch>
              {{dataControlRules.is_rule_actv?'':'No'}}
            </div>
          </ng-template>
        </e-column>
        <e-column field="rule_svrt" headerText="{{dataControl.ruleListColumn.severity}}" width='130'>
          <ng-template #template let-dataControlRules>
            <span title="{{dataControlRules.rule_svrt}}">
              {{dataControlRules.rule_svrt !== null && dataControlRules.rule_svrt?.length > 25 ? dataControlRules.rule_svrt.slice(0,25).concat("...") : dataControlRules.rule_svrt}}
            </span>
          </ng-template>
        </e-column>
        <e-column headerText="{{dataControl.ruleListColumn.editCommands}}" [commands]="gridCommands" width='85'
          textAlign="Center">
        </e-column>
      </e-columns>
    </ejs-grid>
  </form>
  <span class="d-flex float-right top-minus-42" id="customPagerTemplate">
    <span class="text-dark ml-5 mr-2 mt-2 pt-1">Results Per Page</span>
    <span class="mt-1">
      <ejs-dropdownlist name="pageSize" cssClass="e-outline" [dataSource]="['All', '5', '10', '20', '30', '50', '100']"
        value="5" (change)="changePageSize($event)" width="75px">
      </ejs-dropdownlist>
    </span>
  </span>
</div>
<span *ngIf="active">
  <span id="showDCResultsCount" class="top-minus-5">
    <span
      class="text-muted">
      {{(dataControlListGrid.pageSettings.currentPage-1)*dataControlListGrid.pageSettings.pageSize+1}}
      - {{filterMetadata.count > dataControlListGrid.pageSettings.currentPage*dataControlListGrid.pageSettings.pageSize ? dataControlListGrid.pageSettings.currentPage*dataControlListGrid.pageSettings.pageSize : filterMetadata.count}}
      </span>
  </span>
  <span id="addDCRuleTemplate" class="mr-0 top-minus-5">
    <button class="iconTextButton btn btn-primary" data-ripple="true" aria-label="Add New Data Control Rule">
      <img src="assets/images/novartis/add.svg" alt="Add New Rule" />{{dataQualityContent.addNewRule}}</button>
  </span>
  <span id="exportDCTemplate" class="mr-1 top-minus-5">
    <button class="iconButton btn btn-primary" data-ripple="true" aria-label="Export Data Control Rules">
      <img src="assets/images/novartis/upload.svg" alt="Import Rules" />
    </button>
  </span>
  <span id="columnChooserTemplateDC" class=" mr-0 top-minus-8">
    <button class="iconButton btn btn-primary" data-ripple="true" aria-label="Choose Columns To be Displayed">
      <img src="assets/images/novartis/column.svg" alt="Choose Columns" />
    </button>
  </span>
</span>
<ejs-dialog #addNewDataControlDialog
  [header]="isRuleEditMode?dataControl.dialogForm.editRuleHeader:dataControl.dialogForm.addRuleHeader"
  [buttons]="dlgButtons" [visible]="false" [isModal]="true" [position]="position" showCloseIcon="true"
  [animationSettings]="dlgAnimationSettings">
  <ng-template #content>
    <app-data-control-form #dataControlFormComponent (hideDialog)="hideDialog($event)">
    </app-data-control-form>
  </ng-template>
</ejs-dialog>